﻿// Setup the icons, about dialog stuff and flags to be nice.
plugin.SetFlags(gddPluginFlagNone, gddContentFlagHaveDetails);


var city="";
var http; 
var theURL;
var result;
var addrs;  //addresses of all theatres
var items;  //parsed raw data for each theatre
var theatres;  //theatre names
var movies;
var tktlinks;

// Lay out options components, start populating country list
function ShowOptionsDlg(wnd) {
  	
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Please enter a valid location for showtimes\n US City or ZIP Code", 10, 10, 260, 60);  
  wnd.AddControl(gddWndCtrlClassEdit, 0, "cityfield", "", 10, 50,90,20);
  
  wnd.onClose = CitySet;
}

function CitySet(wnd, code){
  if(code== gddIdOK){
  
    var Control = wnd.GetControl("cityfield");
    city = Control.value;
    options.PutValue("cityfield",city);
    //debug.trace(city);
    view_onOpen();
  }
}

function view_onOpen()
{
  plugin.onShowOptionsDlg = ShowOptionsDlg;
  city = options.GetValue("cityfield");
  setCity();
  var interval = 10*60*1000;
  setInterval('view_onOpen()', interval);
}

function setCity()
{
 // city=cityfield.value;
  genQuery(city);
  
}

function alertContent(){
   cnArea.removeAllContentItems();
   cnArea.contentFlags = gddContentFlagHaveDetails;
   
   var curItem = new ContentItem();
   curItem.layout = gddContentItemLayoutNews;
   curItem.heading = "PLEASE ENTER A VALID LOCATION";
   cnArea.AddContentItem(curItem, gddItemDisplayInSidebar);

}

function updateCnArea(){

   cnArea.removeAllContentItems();
   cnArea.contentFlags = gddContentFlagHaveDetails;

   for(var thtrIndex=theatres.length-1;thtrIndex>=0;thtrIndex--){
      var theatre = theatres[thtrIndex];
      var addr = addrs[thtrIndex];
      var curItem = new ContentItem();
      curItem.layout = gddContentItemLayoutNews;
      curItem.heading = theatre;
      // to show in details view
      curItem.snippet = "<b>"+addr+"</b><br>";
      curItem.snippet += "<font color=darkblue>"
      for(var movIndex=0;movIndex<movies[thtrIndex].length;movIndex++)
	  curItem.snippet += "<br>"+movies[thtrIndex][movIndex]+"<br>";
      curItem.snippet += "</font>"
      curItem.onDetailsView = OnDetailsView;
      var tm = new Date();
      tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
      curItem.time_created = tm.getVarDate();

      cnArea.AddContentItem(curItem, gddItemDisplayInSidebar);
   }

   var cityItem =  new ContentItem();
   cityItem.layout = gddContentItemLayoutNews;
   cityItem.heading = city + " Theatres";
   cnArea.AddContentItem(cityItem, gddItemDisplayInSidebar);
}


function OnDetailsView(curItem) {

	var htmlDetails = "<html><head></head><body>";
  	htmlDetails += "<div style='font-family:verdana;font-size:10px;text-align:justify;text-justify:ideograph'>"+curItem.snippet;
  	htmlDetails += "</div></body></html>";
	var control = new DetailsView();

	control.SetContent("", curItem.time_created, htmlDetails, true, curItem.layout);
	control.html_content = true;
	var details = new Object();
	details.details_control = control;
	return details;
}



function genQuery( city )
{
  theURL = "http://www.google.com/movies?sc=1&amp%3Asort=2&near="+city;
  http=getHTTPObject();
  fetchGoogleResults();
}


/*it's soooooooooo tricky here.  I guess JavaScript has some limitation for the length of string arguments. Since when i pass result
 *to another function, in which i access the length of the passed string argument, i can just get partial string. However, 
 *result contains complete html file in handleHttpResponse() function.
 */

function handleHttpResponse() {
  items = new Array();
  theatres = new Array();
  
  if (http.readyState == 4) {
     result=http.responseText;	//fetch the html page returned by Google Movie Search
     if(result.indexOf("Please enter a valid location ")!=-1){
         alertContent();
         return;
     }
     //var len=result.length;
//     debug.trace(len);
//     debug.trace(result.indexOf("Movie title"));
     result = result.substring(result.indexOf("Movie title"));  //the theatre info occurs after "Movie title" token
								//in html file
     var theatre;
     var headpos1 = 0;
     var tailpos1 = 0;
     var headpos2 = 0;
     var tailpos2 = 0;
     var item;
     /*parse html file to get all theatre names and all movie info for each theatre*/
     while((tailpos1 = result.indexOf("</b></a><br><font size=-1>"))!=-1){
        var tmpstring = result.substring(0,tailpos1);
        headpos1 = tmpstring.lastIndexOf("<a");
        tmpstring = result.substring(tailpos1+26);
        tailpos2 = tmpstring.indexOf("</b></a><br><font size=-1>");
        if (tailpos2 == -1){
	    item = result.substring(headpos1);
	    
	    theatre = item.substring(item.indexOf("<b>")+3,item.indexOf("</b></a><br><font size=-1>"));
	//    debug.trace(theatre);
        //    debug.trace(item);
        //    item = result.substring(tailpos1+26);
	    items.push(item);
            theatres.push(theatre);
            break;
	}
        else { 
            var tmpstring2 = tmpstring.substring(0,tailpos2);
            headpos2 =  tmpstring2.lastIndexOf("<a");
            item = result.substring(headpos1,tailpos1+26+headpos2);
	    theatre = item.substring(item.indexOf("<b>")+3,item.indexOf("</b></a><br><font size=-1>"));
 //           debug.trace(theatre);
   //         debug.trace(item);
//	    item = result.substring(tailpos1+26);
	    items.push(item);
	    theatres.push(theatre);
   	    result = result.substring(headpos2+tailpos1+26);
        }
     }

     parseTheatreAddr(items);	// retrieve contact info of all theatres, and save into array addrs
     parseMovieInfo(items);     // retrieve movie info for each theatre and save into 2-dim array movies
     //debug.trace(theatres.length);
     updateCnArea();
  }
}

function parseTheatreAddr(items){
   addrs = new Array();
   for(var i=0;i<items.length;i++) {
       var headpos = items[i].indexOf("</b></a><br><font size=-1>");
       var tailpos = items[i].indexOf("- <a");
       var addr = items[i].substring(headpos+26,tailpos);
//       debug.trace(addr);
       addrs.push(addr);
   }
}

function parseMovieInfo(items){
   movies= new Array();

   for(var i=0;i<items.length;i++) {
       var tmpmovies = new Array();

       var headpos = items[i].indexOf("</b></a><br><font size=-1>");
       var tmpstring = items[i].substring(headpos+26);
       /*movie title always embraced by a pair of <b></b>, which is taken as token
        *while retrieving movie title
        */
       while((headpos = tmpstring.indexOf("<b>"))!=-1){
          var tailpos = tmpstring.indexOf("</b>");
          var movie = "<b>"+tmpstring.substring(headpos+3,tailpos)+"</b>";

          tmpstring = tmpstring.substring(tailpos+3);
          if((tmpstring.substring(9,tmpstring.indexOf(" - <a")).indexOf("<"))==-1){
		/*movie info occurs before the immediate next <a ...*/
	     movie += "<br>"+tmpstring.substring(9,tmpstring.indexOf(" - <a"))+"<br>";   
	     tmpstring = tmpstring.substring(tmpstring.indexOf(" - <a")+5);
	  }
          else{
             movie += "<br>";
             tmpstring = tmpstring.substring(tmpstring.indexOf("</b>")+3);
          }

          var tmpstring2 = tmpstring.substring(0,tmpstring.indexOf("<b>"));
  
    
          var timepos;
          var link;
          var linkpos;
          var time;
          var start=0;
          while((timepos = tmpstring2.indexOf(":",start))!=-1){
             if(tmpstring2.charAt(timepos+3)=='<'||tmpstring2.charAt(timepos+3)=='&'){
		//fandago has link for this time slot, retrieve the url to fandago
		if(tmpstring2.charAt(timepos+4)=='/'&&tmpstring2.charAt(timepos+5)=='a'){
		    link = tmpstring2.substring(0,timepos);
		    linkpos = link.lastIndexOf("<a href=");
		    link = link.substring(linkpos,link.lastIndexOf(">")+1);
		}
                else{ 
                    link="";
                }
                //the minute field takes 2 bits
		if(tmpstring2.charAt(timepos-2)=='>'){
                    time = tmpstring2.substring(timepos-1,timepos+3);
		}
                //the minute field takes 1 bits
		else{
		    time = tmpstring2.substring(timepos-2,timepos+3);
		}
                
                if(link==""){
                    movie += time+"&nbsp;&nbsp;";
                }
                else{
                    movie += link+time+"</a>&nbsp;&nbsp;";
                }
	     }
             start = timepos+1;
           }
           tmpmovies.push(movie);
       }
       movies.push(tmpmovies);
   }
}

function fetchGoogleResults() {
  http.open("GET", theURL, true);
  http.onreadystatechange = handleHttpResponse;
  http.send(null);
}

function getHTTPObject() {
  var xmlhttp;
  try {
    xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
  } catch (e) {
     try {
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
     } catch (E) {
        xmlhttp = false;
     }
  }

  if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
    try {
      xmlhttp = new XMLHttpRequest();
    } catch (e) {
      xmlhttp = false;
    }
  }

  return xmlhttp;
}






